/*****************************************************
Header  : PID CONTROLLER
Version : 1.0
Date    : 30/01/2011 1389/11/10
Author  : SEYD MOHSEN GHASEMIAN
Company : SMGH
Comments: SOURCE WEB: www.picpars.com
          E-mail:   picpars@gmail.com           
*****************************************************/
#include <mega32.h>
#include <delay.h>
#include <lcd.h>
#include <stdio.h>
#include <keypad.h>
#asm
   .equ __lcd_port=0x15 ;PORTC
#endasm
 char buffer[64];
 float SP=50,temp,error,last_error,last_iterm,kp=.025,ki=.0000075,kd=1;
 float pterm,iterm,dterm,D;
 unsigned int  D2,LD,HD;
 
    interrupt [EXT_INT0] void ext_int0_isr(void){
     unsigned char t1=0,key=0,kk[2]={0,0};
     signed char i=0,l=3;
     #asm("cli")
      lcd_clear();
      lcd_putsf("SP=");
       
        while(key!=11){
            key = keypad();
            if(i>=1) i=1;
            l=i+3;
                  if(key==10){
                i=0;
                lcd_clear();
                lcd_putsf("SP="); 
                
                }else if(key!=(10|11))
                
           {   //ESC for keys * & #
            kk[i]=key;
            lcd_gotoxy(l,0);
            sprintf(buffer,"%d",kk[i]);
            lcd_puts(buffer); 
            i++;
           } 
        }
        
         t1+=kk[0]*10;
         t1+=kk[1];
         if (t1) SP=t1; 
     #asm("sei")  
    } 
    
    interrupt [ADC_INT] void adc_isr(void){
        unsigned int adc_data;
        adc_data=ADCW;
        temp=(adc_data*2.56)/1023;
        temp=temp*100;
    }
 
 void main(void){ 
    lcd_init(16);
    
    GICR|=0x40;
    MCUCR=0x02;
    MCUCSR=0x00;
    GIFR=0x40;

    ADMUX=0xC0;  //ch=0
    ADCSRA=0x8D;
    #asm("sei")
    ADCSRA=0xCD;
      
   while(1){
            error=SP-temp; //H1
            pterm=kp*error; //H2
            iterm=(ki*error)+last_iterm; //H3
            dterm=(error-last_error)*kd; //H4
            D=(pterm+iterm+dterm)*100; //H5
            if(D<1) D=1; //H6
            if(D>1020) D=1020; //H7
            last_iterm=iterm; //H8
            last_error=error; //H9
            D2=D;  //H10
            HD=D2/256;  //change to int val [xx xx]  //H11
            LD=D2%256; //H12
            
    DDRD.4=1;
    DDRD.5=1;
    TCCR1A=0xE3;
    TCCR1B=0x0C;
    TCNT1H=0x00;
    TCNT1L=0x00;
    ICR1H=0x00;
    ICR1L=0x00;
    OCR1AH=0x00;
    OCR1AL=0x00;
    OCR1BH=HD;
    OCR1BL=LD;
    
    sprintf(buffer,"T=%3.1f\xdfC SP=%2.1f\nKp=%f\nKi=%f\nKd=%f",temp,SP,pterm,iterm,dterm);
    lcd_clear(); 
    lcd_puts(buffer);
    delay_ms(200);
    ADCSRA=0xCD;
   }
 }
